local dap = require('dap')

dap.adapters['pwa-node'] = {
    type = 'server',
    host = 'localhost',
    port = '${port}',
    executable = {
        command = 'node',
        args = { vim.fn.stdpath('data') .. '/dap/vscode-js-debug/dist/src/dapDebugServer.js', '${port}' },
    },
}

dap.configurations.javascript = {
    {
        type = 'pwa-node',
        request = 'launch',
        name = 'Launch file',
        program = '${file}',
        cwd = '${workspaceFolder}',
    },
}

dap.configurations.typescript = {
    {
        type = 'pwa-node',
        request = 'launch',
        name = 'Launch file',
        runtimeExecutable = 'deno',
        runtimeArgs = { 'run', '--inspect-wait', '--allow-all' },
        program = '${file}',
        cwd = '${workspaceFolder}',
        attachSimplePort = 9229,
    },
}
