local linters_path = vim.fn.stdpath('data') .. '/lint'
local util = require('user.util.misc')

return {
    -- Use '*' for global linters (enabled on all buffers)
    -- and '_' for fallback linters (enabled when nothing else is)
    linters_by_ft = {
        bzl = { 'buildifier' },
        -- dockerfile = { 'hadolint' },
        fish = { 'fish' },
        lua = { 'selene' },
        markdown = {
            -- 'proselint',
            'vale',
        },
        -- org = { 'proselint' },
        -- asciidoc = { 'proselint' },
        proto = { 'buf_lint' },
        sql = { 'sqlfluff' },
        ['*'] = { 'codespell', 'cspell' },
    },

    -- `condition` is custom fields.
    linters = {
        codespell = { cmd = linters_path .. '/codespell/bin/codespell' },
        cspell = {
            cmd = linters_path .. '/cspell/node_modules/.bin/cspell',
            condition = util.root_has_file {
                '.cspell.json',
                'cspell.json',
                '.cSpell.json',
                'cSpell.json',
                'cspell.config.json',
            },
        },
        fish = { args = { '--private', '--no-execute' } },
        proselint = { cmd = linters_path .. '/proselint/bin/proselint' },
        selene = { condition = util.root_has_file('selene.toml') },
        sqlfluff = { cmd = linters_path .. '/sqlfluff/bin/sqlfluff' },
        vale = { condition = util.root_has_file('.vale.ini') },
    },
}
