local vars = require('user.config.vars')

return {
    lsp = {
        -- `lsp_progress` builtin without progress bar
        progress = {
            enabled = false,
            format = {
                '{data.progress.percentage}% ',
                { '{spinner} ', hl_group = 'NoiceLspProgressSpinner' },
                { '{data.progress.title} ', hl_group = 'NoiceLspProgressTitle' },
                { '{data.progress.client} ', hl_group = 'NoiceLspProgressClient' },
            },
        },
        override = {
            ['cmp.entry.get_documentation'] = true,
            ['vim.lsp.util.convert_input_to_markdown_lines'] = true,
            ['vim.lsp.util.stylize_markdown'] = true,
        },
    },
    presets = { command_palette = true, long_message_to_split = true },
    views = {
        mini = { win_options = { winblend = 0 } },
        cmdline_popup = { border = { style = vars.border } },
        confirm = { border = { style = vars.border } },
        popup = { border = { style = vars.border } },
        popupmenu = { border = { style = vars.border } },
        hover = {
            relative = 'cursor',
            border = { style = vars.border },
            position = { row = 2, col = 2 },
        },
    },
    cmdline = {
        format = {
            -- `inc_rename` preset, but with different title
            rename = {
                pattern = '^:%s*IncRename%s+',
                title = ' Rename ',
                icon = '',
                conceal = true,
                opts = {
                    relative = 'cursor',
                    size = { min_width = 20 },
                    position = { row = -3, col = 0 },
                },
            },
        },
    },
    routes = {
        {
            filter = {
                event = 'msg_show',
                find = '%d+L, %d+B',
            },
            view = 'mini',
        },
    },
}
