local wk = require('which-key')
wk.setup {
    plugins = {
        spelling = { enabled = true, suggestions = 30 },
        presets = {
            operators = false,
            motions = false,
            text_objects = false,
            windows = true,
            nav = true,
            z = true,
            g = true,
        },
    },
    key_labels = {
        ['<space>'] = 'SPC',
        ['<cr>'] = 'RET',
        ['<tab>'] = 'TAB',
    },
    icons = {
        breadcrumb = '»',
        separator = '󰜴',
        group = '+',
    },
    window = {
        border = require('user.config.vars').border,
        position = 'bottom',
        winblend = 0,
    },
    layout = { spacing = 10, align = 'center' },
    ignore_missing = false, -- https://github.com/folke/which-key.nvim/issues/355
}

-- Register key group names after <leader>
wk.register({
    d = { name = 'Debug' },
    e = { name = 'Editor' },
    f = {
        name = 'Finder',
        s = { name = 'Symbols' },
    },
    g = { name = 'Git' },
    l = { name = 'LSP' },
    s = { name = 'Search/Replace' },
    t = { name = 'Tasks' },
    p = { name = 'Session' },
    q = { name = 'Quit' },
    u = { name = 'UI' },
    ['<Tab>'] = { name = 'Tab' },
}, { prefix = '<leader>' })

wk.register({
    d = { name = 'Debug' },
    e = { name = 'Editor' },
    g = { name = 'Git' },
    s = { name = 'Search/Replace' },
}, { prefix = '<leader>', mode = 'x' })
