package main

import "github.com/neovim/go-client/nvim"

func findNvimDataDir() (string, error) {
	var nvim_data_dir string

	vim, err := nvim.NewChildProcess(nvim.ChildProcessArgs("--embed"))
	if err != nil {
		return "", err
	}

	if err := vim.ExecLua("return vim.fn.stdpath(...)", &nvim_data_dir, "data"); err != nil {
		return "", err
	}

	return nvim_data_dir, vim.Close()
}
